#ifndef __VIRTUAL_REGISTER_H__
#define __VIRTUAL_REGISTER_H__

#include <stdint.h>

// Virtual register address definition
// Page 0
#define VR_ADDR_SYNC_CODE               0x00
#define VR_ADDR_FW_VERSION              0x02
#define VR_ADDR_BOARD_ID                0x04
#define VR_ADDR_CONTROL_REG             0x06

#define VR_ADDR_SCAN_CONFIG             0x10
#define VR_ADDR_CHANGE_STATUS           0x12
#define VR_ADDR_MUX_0_STATUS            0x14
#define VR_ADDR_MUX_1_STATUS            0x16
#define VR_ADDR_MUX_2_STATUS            0x18
#define VR_ADDR_MUX_3_STATUS            0x1A
#define VR_ADDR_MUX_4_STATUS            0x1C
#define VR_ADDR_MUX_5_STATUS            0x1E
#define VR_ADDR_MUX_6_STATUS            0x20
#define VR_ADDR_MUX_7_STATUS            0x22
#define VR_ADDR_EXTRA_KEY_STATUS        0x24

#define VR_ADDR_TRENDLINE_STATUS        0x30

// Page 1
#define VR_ADDR_MUX_0_KEY_LEVEL_REG_0   0x00
#define VR_ADDR_MUX_0_KEY_LEVEL_REG_1   0x02
#define VR_ADDR_MUX_0_KEY_LEVEL_REG_2   0x04
#define VR_ADDR_MUX_0_KEY_LEVEL_REG_3   0x06
#define VR_ADDR_MUX_0_KEY_LEVEL_REG_4   0x08
#define VR_ADDR_MUX_0_KEY_LEVEL_REG_5   0x0A

#define VR_ADDR_MUX_1_KEY_LEVEL_REG_0   0x10
#define VR_ADDR_MUX_1_KEY_LEVEL_REG_1   0x12
#define VR_ADDR_MUX_1_KEY_LEVEL_REG_2   0x14
#define VR_ADDR_MUX_1_KEY_LEVEL_REG_3   0x16
#define VR_ADDR_MUX_1_KEY_LEVEL_REG_4   0x18
#define VR_ADDR_MUX_1_KEY_LEVEL_REG_5   0x1A

#define VR_ADDR_MUX_2_KEY_LEVEL_REG_0   0x20
#define VR_ADDR_MUX_2_KEY_LEVEL_REG_1   0x22
#define VR_ADDR_MUX_2_KEY_LEVEL_REG_2   0x24
#define VR_ADDR_MUX_2_KEY_LEVEL_REG_3   0x26
#define VR_ADDR_MUX_2_KEY_LEVEL_REG_4   0x28
#define VR_ADDR_MUX_2_KEY_LEVEL_REG_5   0x2A

#define VR_ADDR_MUX_3_KEY_LEVEL_REG_0   0x30
#define VR_ADDR_MUX_3_KEY_LEVEL_REG_1   0x32
#define VR_ADDR_MUX_3_KEY_LEVEL_REG_2   0x34
#define VR_ADDR_MUX_3_KEY_LEVEL_REG_3   0x36
#define VR_ADDR_MUX_3_KEY_LEVEL_REG_4   0x38
#define VR_ADDR_MUX_3_KEY_LEVEL_REG_5   0x3A

#define VR_ADDR_MUX_4_KEY_LEVEL_REG_0   0x40
#define VR_ADDR_MUX_4_KEY_LEVEL_REG_1   0x42
#define VR_ADDR_MUX_4_KEY_LEVEL_REG_2   0x44
#define VR_ADDR_MUX_4_KEY_LEVEL_REG_3   0x46
#define VR_ADDR_MUX_4_KEY_LEVEL_REG_4   0x48
#define VR_ADDR_MUX_4_KEY_LEVEL_REG_5   0x4A

#define VR_ADDR_MUX_5_KEY_LEVEL_REG_0   0x50
#define VR_ADDR_MUX_5_KEY_LEVEL_REG_1   0x52
#define VR_ADDR_MUX_5_KEY_LEVEL_REG_2   0x54
#define VR_ADDR_MUX_5_KEY_LEVEL_REG_3   0x56
#define VR_ADDR_MUX_5_KEY_LEVEL_REG_4   0x58
#define VR_ADDR_MUX_5_KEY_LEVEL_REG_5   0x5A

#define VR_ADDR_MUX_6_KEY_LEVEL_REG_0   0x60
#define VR_ADDR_MUX_6_KEY_LEVEL_REG_1   0x62
#define VR_ADDR_MUX_6_KEY_LEVEL_REG_2   0x64
#define VR_ADDR_MUX_6_KEY_LEVEL_REG_3   0x66
#define VR_ADDR_MUX_6_KEY_LEVEL_REG_4   0x68
#define VR_ADDR_MUX_6_KEY_LEVEL_REG_5   0x6A

#define VR_ADDR_MUX_7_KEY_LEVEL_REG_0   0x70
#define VR_ADDR_MUX_7_KEY_LEVEL_REG_1   0x72
#define VR_ADDR_MUX_7_KEY_LEVEL_REG_2   0x74
#define VR_ADDR_MUX_7_KEY_LEVEL_REG_3   0x76
#define VR_ADDR_MUX_7_KEY_LEVEL_REG_4   0x78
#define VR_ADDR_MUX_7_KEY_LEVEL_REG_5   0x7A

// Page 2
#define VR_ADDR_MUX_0_KEY_0_ADCRAW      0x00
#define VR_ADDR_MUX_0_KEY_1_ADCRAW      0x02
#define VR_ADDR_MUX_0_KEY_2_ADCRAW      0x04
#define VR_ADDR_MUX_0_KEY_3_ADCRAW      0x06
#define VR_ADDR_MUX_0_KEY_4_ADCRAW      0x08
#define VR_ADDR_MUX_0_KEY_5_ADCRAW      0x0A
#define VR_ADDR_MUX_0_KEY_6_ADCRAW      0x0C
#define VR_ADDR_MUX_0_KEY_7_ADCRAW      0x0E
#define VR_ADDR_MUX_0_KEY_8_ADCRAW      0x10
#define VR_ADDR_MUX_0_KEY_9_ADCRAW      0x12
#define VR_ADDR_MUX_0_KEY_10_ADCRAW     0x14

#define VR_ADDR_MUX_1_KEY_0_ADCRAW      0x20
#define VR_ADDR_MUX_1_KEY_1_ADCRAW      0x22
#define VR_ADDR_MUX_1_KEY_2_ADCRAW      0x24
#define VR_ADDR_MUX_1_KEY_3_ADCRAW      0x26
#define VR_ADDR_MUX_1_KEY_4_ADCRAW      0x28
#define VR_ADDR_MUX_1_KEY_5_ADCRAW      0x2A
#define VR_ADDR_MUX_1_KEY_6_ADCRAW      0x2C
#define VR_ADDR_MUX_1_KEY_7_ADCRAW      0x2E
#define VR_ADDR_MUX_1_KEY_8_ADCRAW      0x30
#define VR_ADDR_MUX_1_KEY_9_ADCRAW      0x32
#define VR_ADDR_MUX_1_KEY_10_ADCRAW     0x34

#define VR_ADDR_MUX_2_KEY_0_ADCRAW      0x40
#define VR_ADDR_MUX_2_KEY_1_ADCRAW      0x42
#define VR_ADDR_MUX_2_KEY_2_ADCRAW      0x44
#define VR_ADDR_MUX_2_KEY_3_ADCRAW      0x46
#define VR_ADDR_MUX_2_KEY_4_ADCRAW      0x48
#define VR_ADDR_MUX_2_KEY_5_ADCRAW      0x4A
#define VR_ADDR_MUX_2_KEY_6_ADCRAW      0x4C
#define VR_ADDR_MUX_2_KEY_7_ADCRAW      0x4E
#define VR_ADDR_MUX_2_KEY_8_ADCRAW      0x50
#define VR_ADDR_MUX_2_KEY_9_ADCRAW      0x52
#define VR_ADDR_MUX_2_KEY_10_ADCRAW     0x54

#define VR_ADDR_MUX_3_KEY_0_ADCRAW      0x60
#define VR_ADDR_MUX_3_KEY_1_ADCRAW      0x62
#define VR_ADDR_MUX_3_KEY_2_ADCRAW      0x64
#define VR_ADDR_MUX_3_KEY_3_ADCRAW      0x66
#define VR_ADDR_MUX_3_KEY_4_ADCRAW      0x68
#define VR_ADDR_MUX_3_KEY_5_ADCRAW      0x6A
#define VR_ADDR_MUX_3_KEY_6_ADCRAW      0x6C
#define VR_ADDR_MUX_3_KEY_7_ADCRAW      0x6E
#define VR_ADDR_MUX_3_KEY_8_ADCRAW      0x70
#define VR_ADDR_MUX_3_KEY_9_ADCRAW      0x72
#define VR_ADDR_MUX_3_KEY_10_ADCRAW     0x74

// Page 3
#define VR_ADDR_MUX_4_KEY_0_ADCRAW      0x00
#define VR_ADDR_MUX_4_KEY_1_ADCRAW      0x02
#define VR_ADDR_MUX_4_KEY_2_ADCRAW      0x04
#define VR_ADDR_MUX_4_KEY_3_ADCRAW      0x06
#define VR_ADDR_MUX_4_KEY_4_ADCRAW      0x08
#define VR_ADDR_MUX_4_KEY_5_ADCRAW      0x0A
#define VR_ADDR_MUX_4_KEY_6_ADCRAW      0x0C
#define VR_ADDR_MUX_4_KEY_7_ADCRAW      0x0E
#define VR_ADDR_MUX_4_KEY_8_ADCRAW      0x10
#define VR_ADDR_MUX_4_KEY_9_ADCRAW      0x12
#define VR_ADDR_MUX_4_KEY_10_ADCRAW     0x14

#define VR_ADDR_MUX_5_KEY_0_ADCRAW      0x20
#define VR_ADDR_MUX_5_KEY_1_ADCRAW      0x22
#define VR_ADDR_MUX_5_KEY_2_ADCRAW      0x24
#define VR_ADDR_MUX_5_KEY_3_ADCRAW      0x26
#define VR_ADDR_MUX_5_KEY_4_ADCRAW      0x28
#define VR_ADDR_MUX_5_KEY_5_ADCRAW      0x2A
#define VR_ADDR_MUX_5_KEY_6_ADCRAW      0x2C
#define VR_ADDR_MUX_5_KEY_7_ADCRAW      0x2E
#define VR_ADDR_MUX_5_KEY_8_ADCRAW      0x30
#define VR_ADDR_MUX_5_KEY_9_ADCRAW      0x32
#define VR_ADDR_MUX_5_KEY_10_ADCRAW     0x34

#define VR_ADDR_MUX_6_KEY_0_ADCRAW      0x40
#define VR_ADDR_MUX_6_KEY_1_ADCRAW      0x42
#define VR_ADDR_MUX_6_KEY_2_ADCRAW      0x44
#define VR_ADDR_MUX_6_KEY_3_ADCRAW      0x46
#define VR_ADDR_MUX_6_KEY_4_ADCRAW      0x48
#define VR_ADDR_MUX_6_KEY_5_ADCRAW      0x4A
#define VR_ADDR_MUX_6_KEY_6_ADCRAW      0x4C
#define VR_ADDR_MUX_6_KEY_7_ADCRAW      0x4E
#define VR_ADDR_MUX_6_KEY_8_ADCRAW      0x50
#define VR_ADDR_MUX_6_KEY_9_ADCRAW      0x52
#define VR_ADDR_MUX_6_KEY_10_ADCRAW     0x54

#define VR_ADDR_MUX_7_KEY_0_ADCRAW      0x60
#define VR_ADDR_MUX_7_KEY_1_ADCRAW      0x62
#define VR_ADDR_MUX_7_KEY_2_ADCRAW      0x64
#define VR_ADDR_MUX_7_KEY_3_ADCRAW      0x66
#define VR_ADDR_MUX_7_KEY_4_ADCRAW      0x68
#define VR_ADDR_MUX_7_KEY_5_ADCRAW      0x6A
#define VR_ADDR_MUX_7_KEY_6_ADCRAW      0x6C
#define VR_ADDR_MUX_7_KEY_7_ADCRAW      0x6E
#define VR_ADDR_MUX_7_KEY_8_ADCRAW      0x70
#define VR_ADDR_MUX_7_KEY_9_ADCRAW      0x72
#define VR_ADDR_MUX_7_KEY_10_ADCRAW     0x74

// Page 4
#define VR_ADDR_MUX_0_KEY_0_CONFIG      0x00
#define VR_ADDR_MUX_0_KEY_1_CONFIG      0x02
#define VR_ADDR_MUX_0_KEY_2_CONFIG      0x04
#define VR_ADDR_MUX_0_KEY_3_CONFIG      0x06
#define VR_ADDR_MUX_0_KEY_4_CONFIG      0x08
#define VR_ADDR_MUX_0_KEY_5_CONFIG      0x0A
#define VR_ADDR_MUX_0_KEY_6_CONFIG      0x0C
#define VR_ADDR_MUX_0_KEY_7_CONFIG      0x0E
#define VR_ADDR_MUX_0_KEY_8_CONFIG      0x10
#define VR_ADDR_MUX_0_KEY_9_CONFIG      0x12
#define VR_ADDR_MUX_0_KEY_10_CONFIG     0x14

#define VR_ADDR_MUX_1_KEY_0_CONFIG      0x20
#define VR_ADDR_MUX_1_KEY_1_CONFIG      0x22
#define VR_ADDR_MUX_1_KEY_2_CONFIG      0x24
#define VR_ADDR_MUX_1_KEY_3_CONFIG      0x26
#define VR_ADDR_MUX_1_KEY_4_CONFIG      0x28
#define VR_ADDR_MUX_1_KEY_5_CONFIG      0x2A
#define VR_ADDR_MUX_1_KEY_6_CONFIG      0x2C
#define VR_ADDR_MUX_1_KEY_7_CONFIG      0x2E
#define VR_ADDR_MUX_1_KEY_8_CONFIG      0x30
#define VR_ADDR_MUX_1_KEY_9_CONFIG      0x32
#define VR_ADDR_MUX_1_KEY_10_CONFIG     0x34

#define VR_ADDR_MUX_2_KEY_0_CONFIG      0x40
#define VR_ADDR_MUX_2_KEY_1_CONFIG      0x42
#define VR_ADDR_MUX_2_KEY_2_CONFIG      0x44
#define VR_ADDR_MUX_2_KEY_3_CONFIG      0x46
#define VR_ADDR_MUX_2_KEY_4_CONFIG      0x48
#define VR_ADDR_MUX_2_KEY_5_CONFIG      0x4A
#define VR_ADDR_MUX_2_KEY_6_CONFIG      0x4C
#define VR_ADDR_MUX_2_KEY_7_CONFIG      0x4E
#define VR_ADDR_MUX_2_KEY_8_CONFIG      0x50
#define VR_ADDR_MUX_2_KEY_9_CONFIG      0x52
#define VR_ADDR_MUX_2_KEY_10_CONFIG     0x54

#define VR_ADDR_MUX_3_KEY_0_CONFIG      0x60
#define VR_ADDR_MUX_3_KEY_1_CONFIG      0x62
#define VR_ADDR_MUX_3_KEY_2_CONFIG      0x64
#define VR_ADDR_MUX_3_KEY_3_CONFIG      0x66
#define VR_ADDR_MUX_3_KEY_4_CONFIG      0x68
#define VR_ADDR_MUX_3_KEY_5_CONFIG      0x6A
#define VR_ADDR_MUX_3_KEY_6_CONFIG      0x6C
#define VR_ADDR_MUX_3_KEY_7_CONFIG      0x6E
#define VR_ADDR_MUX_3_KEY_8_CONFIG      0x70
#define VR_ADDR_MUX_3_KEY_9_CONFIG      0x72
#define VR_ADDR_MUX_3_KEY_10_CONFIG     0x74

// Page 5
#define VR_ADDR_MUX_4_KEY_0_CONFIG      0x00
#define VR_ADDR_MUX_4_KEY_1_CONFIG      0x02
#define VR_ADDR_MUX_4_KEY_2_CONFIG      0x04
#define VR_ADDR_MUX_4_KEY_3_CONFIG      0x06
#define VR_ADDR_MUX_4_KEY_4_CONFIG      0x08
#define VR_ADDR_MUX_4_KEY_5_CONFIG      0x0A
#define VR_ADDR_MUX_4_KEY_6_CONFIG      0x0C
#define VR_ADDR_MUX_4_KEY_7_CONFIG      0x0E
#define VR_ADDR_MUX_4_KEY_8_CONFIG      0x10
#define VR_ADDR_MUX_4_KEY_9_CONFIG      0x12
#define VR_ADDR_MUX_4_KEY_10_CONFIG     0x14

#define VR_ADDR_MUX_5_KEY_0_CONFIG      0x20
#define VR_ADDR_MUX_5_KEY_1_CONFIG      0x22
#define VR_ADDR_MUX_5_KEY_2_CONFIG      0x24
#define VR_ADDR_MUX_5_KEY_3_CONFIG      0x26
#define VR_ADDR_MUX_5_KEY_4_CONFIG      0x28
#define VR_ADDR_MUX_5_KEY_5_CONFIG      0x2A
#define VR_ADDR_MUX_5_KEY_6_CONFIG      0x2C
#define VR_ADDR_MUX_5_KEY_7_CONFIG      0x2E
#define VR_ADDR_MUX_5_KEY_8_CONFIG      0x30
#define VR_ADDR_MUX_5_KEY_9_CONFIG      0x32
#define VR_ADDR_MUX_5_KEY_10_CONFIG     0x34

#define VR_ADDR_MUX_6_KEY_0_CONFIG      0x40
#define VR_ADDR_MUX_6_KEY_1_CONFIG      0x42
#define VR_ADDR_MUX_6_KEY_2_CONFIG      0x44
#define VR_ADDR_MUX_6_KEY_3_CONFIG      0x46
#define VR_ADDR_MUX_6_KEY_4_CONFIG      0x48
#define VR_ADDR_MUX_6_KEY_5_CONFIG      0x4A
#define VR_ADDR_MUX_6_KEY_6_CONFIG      0x4C
#define VR_ADDR_MUX_6_KEY_7_CONFIG      0x4E
#define VR_ADDR_MUX_6_KEY_8_CONFIG      0x50
#define VR_ADDR_MUX_6_KEY_9_CONFIG      0x52
#define VR_ADDR_MUX_6_KEY_10_CONFIG     0x54

#define VR_ADDR_MUX_7_KEY_0_CONFIG      0x60
#define VR_ADDR_MUX_7_KEY_1_CONFIG      0x62
#define VR_ADDR_MUX_7_KEY_2_CONFIG      0x64
#define VR_ADDR_MUX_7_KEY_3_CONFIG      0x66
#define VR_ADDR_MUX_7_KEY_4_CONFIG      0x68
#define VR_ADDR_MUX_7_KEY_5_CONFIG      0x6A
#define VR_ADDR_MUX_7_KEY_6_CONFIG      0x6C
#define VR_ADDR_MUX_7_KEY_7_CONFIG      0x6E
#define VR_ADDR_MUX_7_KEY_8_CONFIG      0x70
#define VR_ADDR_MUX_7_KEY_9_CONFIG      0x72
#define VR_ADDR_MUX_7_KEY_10_CONFIG     0x74

// Page 6
#define VR_ADDR_TRENDLINE_STEP_0        0x00
#define VR_ADDR_TRENDLINE_STEP_1        0x02
#define VR_ADDR_TRENDLINE_STEP_2        0x04
#define VR_ADDR_TRENDLINE_STEP_3        0x06
#define VR_ADDR_TRENDLINE_STEP_4        0x08
#define VR_ADDR_TRENDLINE_STEP_5        0x0A
#define VR_ADDR_TRENDLINE_STEP_6        0x0C
#define VR_ADDR_TRENDLINE_STEP_7        0x0E
#define VR_ADDR_TRENDLINE_STEP_8        0x10
#define VR_ADDR_TRENDLINE_STEP_9        0x12
#define VR_ADDR_TRENDLINE_STEP_10       0x14
#define VR_ADDR_TRENDLINE_STEP_11       0x16
#define VR_ADDR_TRENDLINE_STEP_12       0x18
#define VR_ADDR_TRENDLINE_STEP_13       0x1A
#define VR_ADDR_TRENDLINE_STEP_14       0x1C
#define VR_ADDR_TRENDLINE_STEP_15       0x1E
#define VR_ADDR_TRENDLINE_STEP_16       0x20
#define VR_ADDR_TRENDLINE_STEP_17       0x22
#define VR_ADDR_TRENDLINE_STEP_18       0x24
#define VR_ADDR_TRENDLINE_STEP_19       0x26
#define VR_ADDR_TRENDLINE_STEP_20       0x28
#define VR_ADDR_TRENDLINE_STEP_21       0x2A
#define VR_ADDR_TRENDLINE_STEP_22       0x2C
#define VR_ADDR_TRENDLINE_STEP_23       0x2E
#define VR_ADDR_TRENDLINE_STEP_24       0x30
#define VR_ADDR_TRENDLINE_STEP_25       0x32
#define VR_ADDR_TRENDLINE_STEP_26       0x34
#define VR_ADDR_TRENDLINE_STEP_27       0x36
#define VR_ADDR_TRENDLINE_STEP_28       0x38
#define VR_ADDR_TRENDLINE_STEP_29       0x3A
#define VR_ADDR_TRENDLINE_STEP_30       0x3C
#define VR_ADDR_TRENDLINE_STEP_31       0x3E
#define VR_ADDR_TRENDLINE_STEP_32       0x40
#define VR_ADDR_TRENDLINE_STEP_33       0x42
#define VR_ADDR_TRENDLINE_STEP_34       0x44
#define VR_ADDR_TRENDLINE_STEP_35       0x46
#define VR_ADDR_TRENDLINE_STEP_36       0x48
#define VR_ADDR_TRENDLINE_STEP_37       0x4A
#define VR_ADDR_TRENDLINE_STEP_38       0x4C
#define VR_ADDR_TRENDLINE_STEP_39       0x4E
#define VR_ADDR_TRENDLINE_STEP_40       0x50
#define VR_ADDR_TRENDLINE_STEP_41       0x52
#define VR_ADDR_TRENDLINE_STEP_42       0x54
#define VR_ADDR_TRENDLINE_STEP_43       0x56
#define VR_ADDR_TRENDLINE_STEP_44       0x58
#define VR_ADDR_TRENDLINE_STEP_45       0x5A
#define VR_ADDR_TRENDLINE_STEP_46       0x5C
#define VR_ADDR_TRENDLINE_STEP_47       0x5E
#define VR_ADDR_TRENDLINE_STEP_48       0x60
#define VR_ADDR_TRENDLINE_STEP_49       0x62
#define VR_ADDR_TRENDLINE_STEP_50       0x64
#define VR_ADDR_TRENDLINE_STEP_51       0x66
#define VR_ADDR_TRENDLINE_STEP_52       0x68
#define VR_ADDR_TRENDLINE_STEP_53       0x6A
#define VR_ADDR_TRENDLINE_STEP_54       0x6C
#define VR_ADDR_TRENDLINE_STEP_55       0x6E
#define VR_ADDR_TRENDLINE_STEP_56       0x70
#define VR_ADDR_TRENDLINE_STEP_57       0x72
#define VR_ADDR_TRENDLINE_STEP_58       0x74
#define VR_ADDR_TRENDLINE_STEP_59       0x76
#define VR_ADDR_TRENDLINE_STEP_60       0x78
#define VR_ADDR_TRENDLINE_STEP_61       0x7A
#define VR_ADDR_TRENDLINE_STEP_62       0x7C

// Page 7
#define VR_ADDR_TRENDLINE_STEP_63       0x00
#define VR_ADDR_TRENDLINE_STEP_64       0x02
#define VR_ADDR_TRENDLINE_STEP_65       0x04
#define VR_ADDR_TRENDLINE_STEP_66       0x06
#define VR_ADDR_TRENDLINE_STEP_67       0x08
#define VR_ADDR_TRENDLINE_STEP_68       0x0A

// Page 0~7
#define VR_ADDR_PAGE_INDEX              0x7E

typedef struct {
    uint16_t    board_id : 2;
    uint16_t    reserved : 14;
} vr_board_id_t;

typedef struct {
    uint16_t    reset    : 1;
    uint16_t    bsl      : 1;
    uint16_t    reserved : 14;
} vr_control_reg_t;

typedef struct {
    uint16_t    interval         : 3;
    uint16_t    hardware_average : 3;
    uint16_t    enable           : 1;
    uint16_t    change_assert    : 1;
    uint16_t    reserved         : 8;
} vr_scan_config_t;

typedef struct {
    uint16_t    mux_status       : 8;
    uint16_t    extra_key_status : 1;
    uint16_t    reserved         : 7;
} vr_change_status_t;

typedef struct {
    uint16_t    key_status : 11;
    uint16_t    reserved   : 5;
} vr_mux_status_t;

typedef struct {
    uint16_t    wheel    : 1;
    uint16_t    reserved : 15;
} vr_extra_key_status_t;

typedef struct {
    uint16_t    exist    : 1;
    uint16_t    reserved : 15;
} vr_trendline_status_t;

typedef struct {
    uint8_t level[2];
} vr_mux_key_level_reg_t;

typedef struct {
    uint8_t     make_step;
    uint8_t     break_step;
} vr_mux_key_config_t;

typedef struct {
    uint16_t    reserved[63];
    uint16_t    page_index;
} vr_common_t;

typedef struct {
    uint16_t                sync_code;
    uint16_t                fw_version;
    vr_board_id_t           board_id;
    vr_control_reg_t        control_reg;
    uint16_t                reserved0[4];
    vr_scan_config_t        scan_config;
    vr_change_status_t      change_status;
    vr_mux_status_t         mux_status[8];
    vr_extra_key_status_t   extra_key_status;
    uint16_t                reserved1[5];
    vr_trendline_status_t   trendline_status;
    uint16_t                reserved2[39];
} vr_page_0_t;

typedef struct {
    vr_mux_key_level_reg_t  mux_key_level_reg[8][8];
} vr_page_1_t;

typedef struct {
    uint16_t    mux_key_adcraw[4][16];
} vr_page_2_t;

typedef struct {
    uint16_t    mux_key_adcraw[4][16];
} vr_page_3_t;

typedef struct {
    vr_mux_key_config_t mux_key_config[4][16];
} vr_page_4_t;

typedef struct {
    vr_mux_key_config_t mux_key_config[4][16];
} vr_page_5_t;

typedef struct {
    uint16_t    trendline_step[63];
    uint16_t    reserved;
} vr_page_6_t;

typedef struct {
    uint16_t    trendline_step[6];
    uint16_t    reserved[58];
} vr_page_7_t;

typedef union {
    vr_common_t common;
    vr_page_0_t page_0;
    vr_page_1_t page_1;
    vr_page_2_t page_2;
    vr_page_3_t page_3;
    vr_page_4_t page_4;
    vr_page_5_t page_5;
    vr_page_6_t page_6;
    vr_page_7_t page_7;
} vr_t;

extern volatile vr_t vr[8];

#endif